# type: ignore
# generated by datamodel-codegen:
#   filename:  https://raw.githubusercontent.com/VNG-Realisatie/zaken-api/master/src/openapi.yaml
#   timestamp: 2022-11-17T10:45:08+00:00

from __future__ import annotations

from datetime import date, datetime
from enum import Enum
from pydantic import AnyUrl, BaseModel, EmailStr, Field, conint, constr
from typing import Any, Dict, List, Optional, Union
from uuid import UUID


class AardRelatieEnum(Enum):
    vervolg = "vervolg"
    onderwerp = "onderwerp"
    bijdrage = "bijdrage"


class AardRelatieWeergaveEnum(Enum):
    Hoort_bij__omgekeerd__kent = "Hoort bij, omgekeerd: kent"
    Legt_vast__omgekeerd__kan_vastgelegd_zijn_als = "Legt vast, omgekeerd: kan vastgelegd zijn als"


class ArchiefnominatieEnum(Enum):
    blijvend_bewaren = "blijvend_bewaren"
    vernietigen = "vernietigen"


class ArchiefstatusEnum(Enum):
    nog_te_archiveren = "nog_te_archiveren"
    gearchiveerd = "gearchiveerd"
    gearchiveerd_procestermijn_onbekend = "gearchiveerd_procestermijn_onbekend"
    overgedragen = "overgedragen"


class BetalingsindicatieEnum(Enum):
    nvt = "nvt"
    nog_niet = "nog_niet"
    gedeeltelijk = "gedeeltelijk"
    geheel = "geheel"


class BetrokkeneTypeEnum(Enum):
    natuurlijk_persoon = "natuurlijk_persoon"
    niet_natuurlijk_persoon = "niet_natuurlijk_persoon"
    vestiging = "vestiging"
    organisatorische_eenheid = "organisatorische_eenheid"
    medewerker = "medewerker"


class BlankEnum(Enum):
    _ = ""


class BronEnum(Enum):
    ac = "ac"
    nrc = "nrc"
    zrc = "zrc"
    ztc = "ztc"
    drc = "drc"
    brc = "brc"
    cmc = "cmc"
    kc = "kc"
    vrc = "vrc"


class ContactPersoonRol(BaseModel):
    emailadres: Optional[EmailStr] = Field(
        None,
        description="Elektronich postadres waaronder de contactpersoon in de regel bereikbaar is.",
        title="Email",
    )
    functie: Optional[constr(max_length=50)] = Field(
        None,
        description="De aanduiding van de taken, rechten en plichten die de contactpersoon heeft binnen de organisatie van BETROKKENE. ",
        title="functie",
    )
    telefoonnummer: Optional[constr(max_length=20)] = Field(
        None,
        description="Telefoonnummer waaronder de contactpersoon in de regel bereikbaar is.",
        title="telefoonnummer",
    )
    naam: constr(max_length=40) = Field(
        ...,
        description="De opgemaakte naam van de contactpersoon namens de BETROKKENE.",
        title="naam",
    )


class FieldValidationError(BaseModel):
    name: str = Field(..., description="Naam van het veld met ongeldige gegevens", title="name")
    code: str = Field(..., description="Systeemcode die het type fout aangeeft", title="code")
    reason: str = Field(
        ..., description="Uitleg wat er precies fout is met de gegevens", title="reason"
    )


class Fout(BaseModel):
    type: Optional[str] = Field(
        None,
        description="URI referentie naar het type fout, bedoeld voor developers",
        title="type",
    )
    code: str = Field(..., description="Systeemcode die het type fout aangeeft", title="code")
    title: str = Field(..., description="Generieke titel voor het type fout", title="title")
    status: int = Field(..., description="De HTTP status code", title="status")
    detail: str = Field(
        ..., description="Extra informatie bij de fout, indien beschikbaar", title="detail"
    )
    instance: str = Field(
        ...,
        description="URI met referentie naar dit specifiek voorkomen van de fout. Deze kan gebruikt worden in combinatie met server logs, bijvoorbeeld.",
        title="instance",
    )


class GeometryTypeEnum(Enum):
    Point = "Point"
    MultiPoint = "MultiPoint"
    LineString = "LineString"
    MultiLineString = "MultiLineString"
    Polygon = "Polygon"
    MultiPolygon = "MultiPolygon"
    Feature = "Feature"
    FeatureCollection = "FeatureCollection"
    GeometryCollection = "GeometryCollection"


class GeslachtsaanduidingEnum(Enum):
    m = "m"
    v = "v"
    o = "o"


class IndicatieMachtigingEnum(Enum):
    gemachtigde = "gemachtigde"
    machtiginggever = "machtiginggever"


class InnRechtsvormEnum(Enum):
    besloten_vennootschap = "besloten_vennootschap"
    cooperatie_europees_economische_samenwerking = "cooperatie_europees_economische_samenwerking"
    europese_cooperatieve_venootschap = "europese_cooperatieve_venootschap"
    europese_naamloze_vennootschap = "europese_naamloze_vennootschap"
    kerkelijke_organisatie = "kerkelijke_organisatie"
    naamloze_vennootschap = "naamloze_vennootschap"
    onderlinge_waarborg_maatschappij = "onderlinge_waarborg_maatschappij"
    overig_privaatrechtelijke_rechtspersoon = "overig_privaatrechtelijke_rechtspersoon"
    stichting = "stichting"
    vereniging = "vereniging"
    vereniging_van_eigenaars = "vereniging_van_eigenaars"
    publiekrechtelijke_rechtspersoon = "publiekrechtelijke_rechtspersoon"
    vennootschap_onder_firma = "vennootschap_onder_firma"
    maatschap = "maatschap"
    rederij = "rederij"
    commanditaire_vennootschap = "commanditaire_vennootschap"
    kapitaalvennootschap_binnen_eer = "kapitaalvennootschap_binnen_eer"
    overige_buitenlandse_rechtspersoon_vennootschap = (
        "overige_buitenlandse_rechtspersoon_vennootschap"
    )
    kapitaalvennootschap_buiten_eer = "kapitaalvennootschap_buiten_eer"


class KlantContact(BaseModel):
    url: AnyUrl = Field(
        ...,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: UUID = Field(..., description="Unieke resource identifier (UUID4)", title="uuid")
    zaak: AnyUrl = Field(..., description="URL-referentie naar de ZAAK.", title="zaak")
    identificatie: Optional[constr(max_length=14)] = Field(
        None, description="De unieke aanduiding van een KLANTCONTACT", title="identificatie"
    )
    datumtijd: datetime = Field(
        ...,
        description="De datum en het tijdstip waarop het KLANTCONTACT begint",
        title="datumtijd",
    )
    kanaal: Optional[constr(max_length=20)] = Field(
        None,
        description="Het communicatiekanaal waarlangs het KLANTCONTACT gevoerd wordt",
        title="kanaal",
    )
    onderwerp: Optional[constr(max_length=200)] = Field(
        None,
        description="Het onderwerp waarover contact is geweest met de klant.",
        title="onderwerp",
    )
    toelichting: Optional[constr(max_length=1000)] = Field(
        None,
        description="Een toelichting die inhoudelijk het contact met de klant beschrijft.",
        title="toelichting",
    )


class NullEnum(Enum):
    NoneType_None = None


class ObjectAdres(BaseModel):
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    wplWoonplaatsNaam: constr(max_length=80) = Field(..., title="wpl woonplaats naam")
    gorOpenbareRuimteNaam: constr(max_length=80) = Field(
        ...,
        description="Een door het bevoegde gemeentelijke orgaan aan een OPENBARE RUIMTE toegekende benaming",
        title="gor openbare ruimte naam",
    )
    huisnummer: conint(ge=0, le=99999) = Field(..., title="huisnummer")
    huisletter: Optional[constr(max_length=1)] = Field(None, title="huisletter")
    huisnummertoevoeging: Optional[constr(max_length=4)] = Field(
        None, title="huisnummertoevoeging"
    )
    postcode: Optional[constr(max_length=7)] = Field(None, title="postcode")


class ObjectBuurt(BaseModel):
    buurtCode: constr(max_length=2) = Field(
        ..., description="De code behorende bij de naam van de buurt", title="buurt code"
    )
    buurtNaam: constr(max_length=40) = Field(
        ...,
        description="De naam van de buurt, zoals die door het CBS wordt gebruikt.",
        title="buurt naam",
    )
    gemGemeenteCode: constr(max_length=4) = Field(
        ...,
        description="Een numerieke aanduiding waarmee een Nederlandse gemeente uniek wordt aangeduid",
        title="gem gemeente code",
    )
    wykWijkCode: constr(max_length=2) = Field(
        ..., description="De code behorende bij de naam van de wijk", title="wyk wijk code"
    )


class ObjectGemeente(BaseModel):
    gemeenteNaam: constr(max_length=80) = Field(
        ...,
        description="De officiële door de gemeente vastgestelde gemeentenaam.",
        title="gemeente naam",
    )
    gemeenteCode: constr(max_length=4) = Field(
        ...,
        description="Een numerieke aanduiding waarmee een Nederlandse gemeente uniek wordt aangeduid",
        title="gemeente code",
    )


class ObjectGemeentelijkeOpenbareRuimte(BaseModel):
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    openbareRuimteNaam: constr(max_length=80) = Field(
        ...,
        description="Een door het bevoegde gemeentelijke orgaan aan een OPENBARE RUIMTE toegekende benaming",
        title="openbare ruimte naam",
    )


class ObjectInrichtingselementTypeEnum(Enum):
    bak = "bak"
    bord = "bord"
    installatie = "installatie"
    kast = "kast"
    mast = "mast"
    paal = "paal"
    sensor = "sensor"
    straatmeubilair = "straatmeubilair"
    waterinrichtingselement = "waterinrichtingselement"
    weginrichtingselement = "weginrichtingselement"


class ObjectKadastraleOnroerendeZaak(BaseModel):
    kadastraleIdentificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="kadastrale identificatie"
    )
    kadastraleAanduiding: constr(max_length=1000) = Field(
        ...,
        description="De typering van de kadastrale aanduiding van een onroerende zaak conform Kadaster",
        title="kadastrale aanduiding",
    )


class ObjectKunstwerkdeelTypeEnum(Enum):
    keermuur = "keermuur"
    overkluizing = "overkluizing"
    duiker = "duiker"
    faunavoorziening = "faunavoorziening"
    vispassage = "vispassage"
    bodemval = "bodemval"
    coupure = "coupure"
    ponton = "ponton"
    voorde = "voorde"
    hoogspanningsmast = "hoogspanningsmast"
    gemaal = "gemaal"
    perron = "perron"
    sluis = "sluis"
    strekdam = "strekdam"
    steiger = "steiger"
    stuw = "stuw"


class ObjectMaatschappelijkeActiviteit(BaseModel):
    kvkNummer: constr(max_length=8) = Field(
        ...,
        description="Landelijk uniek identificerend administratienummer van een MAATSCHAPPELIJKE ACTIVITEIT zoals toegewezen door de Kamer van Koophandel (KvK).",
        title="kvk nummer",
    )
    handelsnaam: constr(max_length=200) = Field(
        ..., description="De naam waaronder de onderneming handelt.", title="handelsnaam"
    )


class ObjectOpenbareRuimte(BaseModel):
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    wplWoonplaatsNaam: constr(max_length=80) = Field(..., title="wpl woonplaats naam")
    gorOpenbareRuimteNaam: constr(max_length=80) = Field(
        ...,
        description="Een door het bevoegde gemeentelijke orgaan aan een OPENBARE RUIMTE toegekende benaming",
        title="gor openbare ruimte naam",
    )


class ObjectOverige(BaseModel):
    overigeData: Dict[str, Any] = Field(..., title="overige data")


class ObjectPand(BaseModel):
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )


class ObjectSpoorbaandeelTypeEnum(Enum):
    breedspoor = "breedspoor"
    normaalspoor = "normaalspoor"
    smalspoor = "smalspoor"
    spoorbaan = "spoorbaan"


class ObjectTerreindeel(BaseModel):
    type: constr(max_length=40) = Field(..., title="type")
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    naam: Optional[constr(max_length=500)] = Field(
        None, description="De benaming van het OBJECT", title="naam"
    )


class ObjectTypeEnum(Enum):
    adres = "adres"
    besluit = "besluit"
    buurt = "buurt"
    enkelvoudig_document = "enkelvoudig_document"
    gemeente = "gemeente"
    gemeentelijke_openbare_ruimte = "gemeentelijke_openbare_ruimte"
    huishouden = "huishouden"
    inrichtingselement = "inrichtingselement"
    kadastrale_onroerende_zaak = "kadastrale_onroerende_zaak"
    kunstwerkdeel = "kunstwerkdeel"
    maatschappelijke_activiteit = "maatschappelijke_activiteit"
    medewerker = "medewerker"
    natuurlijk_persoon = "natuurlijk_persoon"
    niet_natuurlijk_persoon = "niet_natuurlijk_persoon"
    openbare_ruimte = "openbare_ruimte"
    organisatorische_eenheid = "organisatorische_eenheid"
    pand = "pand"
    spoorbaandeel = "spoorbaandeel"
    status = "status"
    terreindeel = "terreindeel"
    terrein_gebouwd_object = "terrein_gebouwd_object"
    vestiging = "vestiging"
    waterdeel = "waterdeel"
    wegdeel = "wegdeel"
    wijk = "wijk"
    woonplaats = "woonplaats"
    woz_deelobject = "woz_deelobject"
    woz_object = "woz_object"
    woz_waarde = "woz_waarde"
    zakelijk_recht = "zakelijk_recht"
    overige = "overige"


class ObjectTypeOverigeDefinitie(BaseModel):
    url: AnyUrl = Field(
        ...,
        description="URL-referentie naar de objecttype resource in een API. Deze resource moet de [JSON-schema](https://json-schema.org/)-definitie van het objecttype bevatten.",
        title="Objecttype-URL",
    )
    schema_: constr(max_length=100) = Field(
        ...,
        alias="schema",
        description="Een geldige [jq](http://stedolan.github.io/jq/) expressie. Dit wordt gecombineerd met de resource uit het `url`-attribuut om het schema van het objecttype uit te lezen. Bijvoorbeeld: `.jsonSchema`.",
        title="schema-pad",
    )
    objectData: constr(max_length=100) = Field(
        ...,
        description="Een geldige [jq](http://stedolan.github.io/jq/) expressie. Dit wordt gecombineerd met de JSON data uit de OBJECT url om de objectgegevens uit te lezen en de vorm van de gegevens tegen het schema te valideren. Bijvoorbeeld: `.record.data`.",
        title="objectgegevens-pad",
    )


class ObjectWegdeel(BaseModel):
    type: constr(max_length=100) = Field(..., title="type")
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    naam: Optional[constr(max_length=500)] = Field(
        None, description="De benaming van het OBJECT", title="naam"
    )


class ObjectWijk(BaseModel):
    wijkCode: constr(max_length=2) = Field(
        ..., description="De code behorende bij de naam van de wijk.", title="wijk code"
    )
    wijkNaam: constr(max_length=40) = Field(
        ...,
        description="De naam van de wijk, zoals die door het CBS wordt gebruikt.",
        title="wijk naam",
    )
    gemGemeenteCode: constr(max_length=4) = Field(
        ...,
        description="Een numerieke aanduiding waarmee een Nederlandse gemeente uniek wordt aangeduid",
        title="gem gemeente code",
    )


class ObjectWoonplaats(BaseModel):
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    woonplaatsNaam: constr(max_length=80) = Field(
        ...,
        description="De door het bevoegde gemeentelijke orgaan aan een WOONPLAATS toegekende benaming.",
        title="woonplaats naam",
    )


class Opschorting(BaseModel):
    indicatie: bool = Field(
        ...,
        description="Aanduiding of de behandeling van de ZAAK tijdelijk is opgeschort.",
        title="indicatie opschorting",
    )
    reden: constr(max_length=200) = Field(
        ...,
        description="Omschrijving van de reden voor het opschorten van de behandeling van de zaak.",
        title="reden opschorting",
    )


class PaginatedKlantContactList(BaseModel):
    count: Optional[int] = Field(None, example=123)
    next: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=4")
    previous: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=2")
    results: Optional[List[KlantContact]] = None


class PatchedResultaat(BaseModel):
    url: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: Optional[UUID] = Field(
        None, description="Unieke resource identifier (UUID4)", title="uuid"
    )
    zaak: Optional[AnyUrl] = Field(None, description="URL-referentie naar de ZAAK.", title="zaak")
    resultaattype: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar het RESULTAATTYPE (in de Catalogi API).",
        title="resultaattype",
    )
    toelichting: Optional[constr(max_length=1000)] = Field(
        None,
        description="Een toelichting op wat het resultaat van de zaak inhoudt.",
        title="toelichting",
    )


class PatchedZaakEigenschap(BaseModel):
    url: Optional[AnyUrl] = Field(None, title="url")
    uuid: Optional[UUID] = Field(
        None, description="Unieke resource identifier (UUID4)", title="uuid"
    )
    zaak: Optional[AnyUrl] = Field(None, title="zaak")
    eigenschap: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar de EIGENSCHAP (in de Catalogi API).",
        title="eigenschap",
    )
    naam: Optional[str] = Field(
        None,
        description="De naam van de EIGENSCHAP (overgenomen uit de Catalogi API).",
        title=" naam",
    )
    waarde: Optional[str] = Field(None, title="waarde")


class PatchedZaakInformatieObject(BaseModel):
    url: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: Optional[UUID] = Field(
        None, description="Unieke resource identifier (UUID4)", title="uuid"
    )
    informatieobject: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar het INFORMATIEOBJECT (in de Documenten API), waar ook de relatieinformatie opgevraagd kan worden.",
        title="informatieobject",
    )
    zaak: Optional[AnyUrl] = Field(None, description="URL-referentie naar de ZAAK.", title="zaak")
    aardRelatieWeergave: Optional[AardRelatieWeergaveEnum] = Field(
        None, title="aardRelatieWeergave"
    )
    titel: Optional[constr(max_length=200)] = Field(
        None,
        description="De naam waaronder het INFORMATIEOBJECT binnen het OBJECT bekend is.",
        title="titel",
    )
    beschrijving: Optional[str] = Field(
        None,
        description="Een op het object gerichte beschrijving van de inhoud vanhet INFORMATIEOBJECT.",
        title="beschrijving",
    )
    registratiedatum: Optional[datetime] = Field(
        None,
        description="De datum waarop de behandelende organisatie het INFORMATIEOBJECT heeft geregistreerd bij het OBJECT. Geldige waardes zijn datumtijden gelegen op of voor de huidige datum en tijd.",
        title="registratiedatum",
    )
    vernietigingsdatum: Optional[datetime] = Field(
        None,
        description="De datum waarop het informatieobject uit het zaakdossier verwijderd moet worden.",
        title="vernietigingsdatum",
    )
    status: Optional[AnyUrl] = Field(
        None,
        description="De bij de desbetreffende ZAAK behorende STATUS waarvoor het ZAAK-INFORMATIEOBJECT relevant is (geweest) met het oog op het bereiken van die STATUS en/of de communicatie daarover.",
        title="status",
    )


class PatchedZaakObject(BaseModel):
    url: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: Optional[UUID] = Field(
        None, description="Unieke resource identifier (UUID4)", title="uuid"
    )
    zaak: Optional[AnyUrl] = Field(None, description="URL-referentie naar de ZAAK.", title="zaak")
    object: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar de resource die het OBJECT beschrijft.",
        title="object",
    )
    zaakobjecttype: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar het ZAAKOBJECTTYPE (in de Catalogi API).",
        title="zaakobjecttype",
    )
    objectType: Optional[ObjectTypeEnum] = Field(
        None,
        description="Beschrijft het type OBJECT gerelateerd aan de ZAAK. Als er geen passend type is, dan moet het type worden opgegeven onder `objectTypeOverige`.\n\nUitleg bij mogelijke waarden:\n\n* `adres` - Adres\n* `besluit` - Besluit\n* `buurt` - Buurt\n* `enkelvoudig_document` - Enkelvoudig document\n* `gemeente` - Gemeente\n* `gemeentelijke_openbare_ruimte` - Gemeentelijke openbare ruimte\n* `huishouden` - Huishouden\n* `inrichtingselement` - Inrichtingselement\n* `kadastrale_onroerende_zaak` - Kadastrale onroerende zaak\n* `kunstwerkdeel` - Kunstwerkdeel\n* `maatschappelijke_activiteit` - Maatschappelijke activiteit\n* `medewerker` - Medewerker\n* `natuurlijk_persoon` - Natuurlijk persoon\n* `niet_natuurlijk_persoon` - Niet-natuurlijk persoon\n* `openbare_ruimte` - Openbare ruimte\n* `organisatorische_eenheid` - Organisatorische eenheid\n* `pand` - Pand\n* `spoorbaandeel` - Spoorbaandeel\n* `status` - Status\n* `terreindeel` - Terreindeel\n* `terrein_gebouwd_object` - Terrein gebouwd object\n* `vestiging` - Vestiging\n* `waterdeel` - Waterdeel\n* `wegdeel` - Wegdeel\n* `wijk` - Wijk\n* `woonplaats` - Woonplaats\n* `woz_deelobject` - Woz deel object\n* `woz_object` - Woz object\n* `woz_waarde` - Woz waarde\n* `zakelijk_recht` - Zakelijk recht\n* `overige` - Overige",
        title="object type",
    )
    objectTypeOverige: Optional[constr(regex=r"[a-z\_]+", max_length=100)] = Field(
        None,
        description='Beschrijft het type OBJECT als `objectType` de waarde "overige" heeft.',
        title="object type overige",
    )
    objectTypeOverigeDefinitie: Optional[ObjectTypeOverigeDefinitie] = Field(
        None,
        description='Verwijzing naar het schema van het type OBJECT als `objectType` de waarde "overige" heeft.\n\n* De URL referentie moet naar een JSON endpoint   wijzen waarin het objecttype gedefinieerd is, inclusief het   [JSON-schema](https://json-schema.org/).\n* Gebruik het `schema` attribuut om te verwijzen naar het schema binnen   de objecttype resource (deze gebruikt het   [jq](http://stedolan.github.io/jq/) formaat.\n* Gebruik het `objectData` attribuut om te verwijzen naar de gegevens   binnen het OBJECT. Deze gebruikt ook het   [jq](http://stedolan.github.io/jq/) formaat.\n\nIndien je hier gebruikt van maakt, dan moet je een OBJECT url opgeven en is het gebruik van objectIdentificatie niet mogelijk. De opgegeven OBJECT url wordt gevalideerd tegen het schema van het opgegeven objecttype.',
        title="definitie object type overige",
    )
    relatieomschrijving: Optional[constr(max_length=80)] = Field(
        None,
        description="Omschrijving van de betrekking tussen de ZAAK en het OBJECT.",
        title="relatieomschrijving",
    )


class Point2D(BaseModel):
    __root__: List[float] = Field(..., max_items=2, min_items=2, title="Point2D")


class Processobject(BaseModel):
    datumkenmerk: constr(max_length=250) = Field(
        ...,
        description="De naam van de attribuutsoort van het procesobject dat bepalend is voor het einde van de procestermijn.",
        title="datumkenmerk",
    )
    identificatie: constr(max_length=250) = Field(
        ..., description="De unieke aanduiding van het procesobject.", title="identificatie"
    )
    objecttype: constr(max_length=250) = Field(
        ..., description="Het soort object dat het procesobject representeert.", title="objecttype"
    )
    registratie: constr(max_length=250) = Field(
        ...,
        description="De naam van de registratie waarvan het procesobject deel uit maakt.",
        title="registratie",
    )


class RelevanteZaak(BaseModel):
    url: AnyUrl = Field(..., title="URL-referentie naar de ZAAK.")
    aardRelatie: AardRelatieEnum = Field(
        ...,
        description="Benamingen van de aard van de relaties van andere zaken tot (onderhanden) zaken.\n\nUitleg bij mogelijke waarden:\n\n* `vervolg` - De andere zaak gaf aanleiding tot het starten van de onderhanden zaak.\n* `onderwerp` - De andere zaak is relevant voor cq. is onderwerp van de onderhanden zaak.\n* `bijdrage` - Aan het bereiken van de uitkomst van de andere zaak levert de onderhanden zaak een bijdrage.",
        title="aard relatie",
    )


class Resultaat(BaseModel):
    url: AnyUrl = Field(
        ...,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: UUID = Field(..., description="Unieke resource identifier (UUID4)", title="uuid")
    zaak: AnyUrl = Field(..., description="URL-referentie naar de ZAAK.", title="zaak")
    resultaattype: AnyUrl = Field(
        ...,
        description="URL-referentie naar het RESULTAATTYPE (in de Catalogi API).",
        title="resultaattype",
    )
    toelichting: Optional[constr(max_length=1000)] = Field(
        None,
        description="Een toelichting op wat het resultaat van de zaak inhoudt.",
        title="toelichting",
    )


class StatussenItem(BaseModel):
    __root__: AnyUrl = Field(..., title="")


class Rol(BaseModel):
    url: AnyUrl = Field(
        ...,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: UUID = Field(..., description="Unieke resource identifier (UUID4)", title="uuid")
    zaak: AnyUrl = Field(..., description="URL-referentie naar de ZAAK.", title="zaak")
    betrokkene: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar een betrokkene gerelateerd aan de ZAAK.",
        title="betrokkene",
    )
    betrokkeneType: BetrokkeneTypeEnum = Field(
        ...,
        description="Type van de `betrokkene`.\n\nUitleg bij mogelijke waarden:\n\n* `natuurlijk_persoon` - Natuurlijk persoon\n* `niet_natuurlijk_persoon` - Niet-natuurlijk persoon\n* `vestiging` - Vestiging\n* `organisatorische_eenheid` - Organisatorische eenheid\n* `medewerker` - Medewerker",
        title="betrokkene type",
    )
    afwijkendeNaamBetrokkene: Optional[constr(max_length=625)] = Field(
        None,
        description="De naam van de betrokkene waaronder deze in relatie tot de zaak aangesproken wil worden.",
        title="afwijkende naam betrokkene",
    )
    roltype: AnyUrl = Field(
        ...,
        description="URL-referentie naar een roltype binnen het ZAAKTYPE van de ZAAK.",
        title="roltype",
    )
    omschrijving: str = Field(
        ...,
        description="Omschrijving van de aard van de ROL, afgeleid uit het ROLTYPE.",
        title="omschrijving",
    )
    omschrijvingGeneriek: str = Field(
        ...,
        description="Algemeen gehanteerde benaming van de aard van de ROL, afgeleid uit het ROLTYPE.\n\nUitleg bij mogelijke waarden:\n\n* `adviseur` - (Adviseur) Kennis in dienst stellen van de behandeling van (een deel van) een zaak.\n* `behandelaar` - (Behandelaar) De vakinhoudelijke behandeling doen van (een deel van) een zaak.\n* `belanghebbende` - (Belanghebbende) Vanuit eigen en objectief belang rechtstreeks betrokken zijn bij de behandeling en/of de uitkomst van een zaak.\n* `beslisser` - (Beslisser) Nemen van besluiten die voor de uitkomst van een zaak noodzakelijk zijn.\n* `initiator` - (Initiator) Aanleiding geven tot de start van een zaak ..\n* `klantcontacter` - (Klantcontacter) Het eerste aanspreekpunt zijn voor vragen van burgers en bedrijven ..\n* `zaakcoordinator` - (Zaakcoördinator) Er voor zorg dragen dat de behandeling van de zaak in samenhang uitgevoerd wordt conform de daarover gemaakte afspraken.\n* `mede_initiator` - Mede-initiator",
        title="omschrijving generiek",
    )
    roltoelichting: constr(max_length=1000) = Field(..., title="roltoelichting")
    registratiedatum: datetime = Field(
        ..., description="De datum waarop dit object is geregistreerd.", title="registratiedatum"
    )
    indicatieMachtiging: Optional[Union[IndicatieMachtigingEnum, BlankEnum]] = Field(
        None,
        description="Indicatie machtiging\n\nUitleg bij mogelijke waarden:\n\n* `gemachtigde` - De betrokkene in de rol bij de zaak is door een andere betrokkene bij dezelfde zaak gemachtigd om namens hem of haar te handelen\n* `machtiginggever` - De betrokkene in de rol bij de zaak heeft een andere betrokkene bij dezelfde zaak gemachtigd om namens hem of haar te handelen",
        title="indicatie machtiging",
    )
    contactpersoonRol: Optional[ContactPersoonRol] = Field(
        None,
        description="De gegevens van de persoon die anderen desgevraagd in contact brengt met medewerkers van de BETROKKENE, een NIET-NATUURLIJK PERSOON of VESTIGING zijnde, of met BETROKKENE zelf, een NATUURLIJK PERSOON zijnde , vanuit het belang van BETROKKENE in haar ROL bij een ZAAK.",
        title="contactpersoonRol",
    )
    statussen: List[StatussenItem] = Field(
        ...,
        description="De BETROKKENE die in zijn/haar ROL in een ZAAK heeft geregistreerd dat STATUSsen in die ZAAK bereikt zijn.",
        title="statussen",
        unique_items=True,
    )


class RolMedewerker(BaseModel):
    identificatie: Optional[constr(max_length=24)] = Field(
        None, description="Een korte unieke aanduiding van de MEDEWERKER.", title="identificatie"
    )
    achternaam: Optional[constr(max_length=200)] = Field(
        None,
        description="De achternaam zoals de MEDEWERKER die in het dagelijkse verkeer gebruikt.",
        title="achternaam",
    )
    voorletters: Optional[constr(max_length=20)] = Field(
        None,
        description="De verzameling letters die gevormd wordt door de eerste letter van alle in volgorde voorkomende voornamen.",
        title="voorletters",
    )
    voorvoegselAchternaam: Optional[constr(max_length=10)] = Field(
        None,
        description="Dat deel van de geslachtsnaam dat voorkomt in Tabel 36 (GBA), voorvoegseltabel, en door een spatie van de geslachtsnaam is",
        title="voorvoegsel achternaam",
    )


class RolOrganisatorischeEenheid(BaseModel):
    identificatie: Optional[constr(max_length=24)] = Field(
        None,
        description="Een korte identificatie van de organisatorische eenheid.",
        title="identificatie",
    )
    naam: Optional[constr(max_length=50)] = Field(
        None, description="De feitelijke naam van de organisatorische eenheid.", title="naam"
    )
    isGehuisvestIn: Optional[constr(max_length=24)] = Field(None, title="is gehuisvest in")


class ZaakinformatieobjectenItem(BaseModel):
    __root__: AnyUrl = Field(..., title="")


class Status(BaseModel):
    url: AnyUrl = Field(
        ...,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: UUID = Field(..., description="Unieke resource identifier (UUID4)", title="uuid")
    zaak: AnyUrl = Field(..., description="URL-referentie naar de ZAAK.", title="zaak")
    statustype: AnyUrl = Field(
        ...,
        description="URL-referentie naar het STATUSTYPE (in de Catalogi API).",
        title="statustype",
    )
    datumStatusGezet: datetime = Field(
        ...,
        description="De datum waarop de ZAAK de status heeft verkregen.",
        title="datum status gezet",
    )
    statustoelichting: Optional[constr(max_length=1000)] = Field(
        None,
        description="Een, voor de initiator van de zaak relevante, toelichting op de status van een zaak.",
        title="statustoelichting",
    )
    indicatieLaatstGezetteStatus: Optional[bool] = Field(
        None,
        description="Het gegeven is afleidbaar uit de historie van de attribuutsoort Datum status gezet van van alle statussen bij de desbetreffende zaak.",
        title="indicatie laatst gezette status",
    )
    gezetdoor: Optional[AnyUrl] = Field(
        None,
        description="De BETROKKENE die in zijn/haar ROL in een ZAAK heeft geregistreerd dat STATUSsen in die ZAAK bereikt zijn.",
        title="Gezet door",
    )
    zaakinformatieobjecten: List[ZaakinformatieobjectenItem] = Field(
        ..., title="status", unique_items=True
    )


class SubVerblijfBuitenland(BaseModel):
    lndLandcode: constr(max_length=4) = Field(
        ...,
        description="De code, behorende bij de landnaam, zoals opgenomen in de Land/Gebied-tabel van de BRP.",
        title="lnd landcode",
    )
    lndLandnaam: constr(max_length=40) = Field(
        ...,
        description="De naam van het land, zoals opgenomen in de Land/Gebied-tabel van de BRP.",
        title="lnd landnaam",
    )
    subAdresBuitenland_1: Optional[constr(max_length=35)] = Field(
        None, title="sub adres buitenland 1"
    )
    subAdresBuitenland_2: Optional[constr(max_length=35)] = Field(
        None, title="sub adres buitenland 2"
    )
    subAdresBuitenland_3: Optional[constr(max_length=35)] = Field(
        None, title="sub adres buitenland 3"
    )


class TerreinGebouwdObjectAdres(BaseModel):
    numIdentificatie: Optional[constr(max_length=100)] = Field(None, title="num identificatie")
    oaoIdentificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    wplWoonplaatsNaam: constr(max_length=80) = Field(..., title="wpl woonplaats naam")
    gorOpenbareRuimteNaam: constr(max_length=80) = Field(
        ...,
        description="Een door het bevoegde gemeentelijke orgaan aan een OPENBARE RUIMTE toegekende benaming",
        title="gor openbare ruimte naam",
    )
    aoaPostcode: Optional[constr(max_length=7)] = Field(None, title="postcode")
    aoaHuisnummer: conint(ge=0, le=99999) = Field(..., title="huisnummer")
    aoaHuisletter: Optional[constr(max_length=1)] = Field(None, title="huisletter")
    aoaHuisnummertoevoeging: Optional[constr(max_length=4)] = Field(
        None, title="huisnummertoevoeging"
    )
    ogoLocatieAanduiding: Optional[constr(max_length=100)] = Field(
        None, title="locatie aanduiding"
    )


class TypeWaterdeelEnum(Enum):
    zee = "zee"
    waterloop = "waterloop"
    watervlakte = "watervlakte"
    greppel_droge_sloot = "greppel_droge_sloot"


class ValidatieFout(BaseModel):
    type: Optional[str] = Field(
        None,
        description="URI referentie naar het type fout, bedoeld voor developers",
        title="type",
    )
    code: str = Field(..., description="Systeemcode die het type fout aangeeft", title="code")
    title: str = Field(..., description="Generieke titel voor het type fout", title="title")
    status: int = Field(..., description="De HTTP status code", title="status")
    detail: str = Field(
        ..., description="Extra informatie bij de fout, indien beschikbaar", title="detail"
    )
    instance: str = Field(
        ...,
        description="URI met referentie naar dit specifiek voorkomen van de fout. Deze kan gebruikt worden in combinatie met server logs, bijvoorbeeld.",
        title="instance",
    )
    invalidParams: List[FieldValidationError] = Field(..., title="invalidParams")


class VerblijfsAdres(BaseModel):
    aoaIdentificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    wplWoonplaatsNaam: constr(max_length=80) = Field(..., title="wpl woonplaats naam")
    gorOpenbareRuimteNaam: constr(max_length=80) = Field(
        ...,
        description="Een door het bevoegde gemeentelijke orgaan aan een OPENBARE RUIMTE toegekende benaming",
        title="gor openbare ruimte naam",
    )
    aoaPostcode: Optional[constr(max_length=7)] = Field(None, title="postcode")
    aoaHuisnummer: conint(ge=0, le=99999) = Field(..., title="huisnummer")
    aoaHuisletter: Optional[constr(max_length=1)] = Field(None, title="huisletter")
    aoaHuisnummertoevoeging: Optional[constr(max_length=4)] = Field(
        None, title="huisnummertoevoeging"
    )
    inpLocatiebeschrijving: Optional[constr(max_length=1000)] = Field(
        None, title="locatie omschrijving"
    )


class Verlenging(BaseModel):
    reden: constr(max_length=200) = Field(
        ...,
        description="Omschrijving van de reden voor het verlengen van de behandeling van de zaak.",
        title="reden verlenging",
    )
    duur: str = Field(
        ...,
        description="Het aantal werkbare dagen waarmee de doorlooptijd van de behandeling van de ZAAK is verlengd (of verkort) ten opzichte van de eerder gecommuniceerde doorlooptijd.",
        title="duur verlenging",
    )


class VertrouwelijkheidaanduidingEnum(Enum):
    openbaar = "openbaar"
    beperkt_openbaar = "beperkt_openbaar"
    intern = "intern"
    zaakvertrouwelijk = "zaakvertrouwelijk"
    vertrouwelijk = "vertrouwelijk"
    confidentieel = "confidentieel"
    geheim = "geheim"
    zeer_geheim = "zeer_geheim"


class Wijzigingen(BaseModel):
    oud: Optional[Dict[str, Any]] = Field(
        None,
        description="Volledige JSON body van het object zoals dat bestond voordat de actie heeft plaatsgevonden.",
        title="oud",
    )
    nieuw: Optional[Dict[str, Any]] = Field(
        None, description="Volledige JSON body van het object na de actie.", title="nieuw"
    )


class WozObjectAdres(BaseModel):
    aoaIdentificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    wplWoonplaatsNaam: constr(max_length=80) = Field(..., title="wpl woonplaats naam")
    gorOpenbareRuimteNaam: constr(max_length=80) = Field(
        ...,
        description="Een door het bevoegde gemeentelijke orgaan aan een OPENBARE RUIMTE toegekende benaming",
        title="gor openbare ruimte naam",
    )
    aoaPostcode: Optional[constr(max_length=7)] = Field(None, title="postcode")
    aoaHuisnummer: conint(ge=0, le=99999) = Field(..., title="huisnummer")
    aoaHuisletter: Optional[constr(max_length=1)] = Field(None, title="huisletter")
    aoaHuisnummertoevoeging: Optional[constr(max_length=4)] = Field(
        None, title="huisnummertoevoeging"
    )
    locatieOmschrijving: Optional[constr(max_length=1000)] = Field(
        None, title="locatie omschrijving"
    )


class ZaakBesluit(BaseModel):
    url: AnyUrl = Field(..., title="url")
    uuid: UUID = Field(..., description="Unieke resource identifier (UUID4)", title="uuid")
    besluit: AnyUrl = Field(
        ...,
        description="URL-referentie naar het BESLUIT (in de Besluiten API), waar ook de relatieinformatie opgevraagd kan worden.",
        title="besluit",
    )


class ZaakContactMoment(BaseModel):
    url: AnyUrl = Field(
        ...,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: UUID = Field(..., description="Unieke resource identifier (UUID4)", title="uuid")
    zaak: AnyUrl = Field(..., description="URL-referentie naar de ZAAK.", title="zaak")
    contactmoment: AnyUrl = Field(
        ...,
        description="URL-referentie naar het CONTACTMOMENT (in de Klantinteractie API)",
        title="contactmoment",
    )


class ZaakEigenschap(BaseModel):
    url: AnyUrl = Field(..., title="url")
    uuid: UUID = Field(..., description="Unieke resource identifier (UUID4)", title="uuid")
    zaak: AnyUrl = Field(..., title="zaak")
    eigenschap: AnyUrl = Field(
        ...,
        description="URL-referentie naar de EIGENSCHAP (in de Catalogi API).",
        title="eigenschap",
    )
    naam: str = Field(
        ...,
        description="De naam van de EIGENSCHAP (overgenomen uit de Catalogi API).",
        title=" naam",
    )
    waarde: str = Field(..., title="waarde")


class ZaakInformatieObject(BaseModel):
    url: AnyUrl = Field(
        ...,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: UUID = Field(..., description="Unieke resource identifier (UUID4)", title="uuid")
    informatieobject: AnyUrl = Field(
        ...,
        description="URL-referentie naar het INFORMATIEOBJECT (in de Documenten API), waar ook de relatieinformatie opgevraagd kan worden.",
        title="informatieobject",
    )
    zaak: AnyUrl = Field(..., description="URL-referentie naar de ZAAK.", title="zaak")
    aardRelatieWeergave: AardRelatieWeergaveEnum = Field(..., title="aardRelatieWeergave")
    titel: Optional[constr(max_length=200)] = Field(
        None,
        description="De naam waaronder het INFORMATIEOBJECT binnen het OBJECT bekend is.",
        title="titel",
    )
    beschrijving: Optional[str] = Field(
        None,
        description="Een op het object gerichte beschrijving van de inhoud vanhet INFORMATIEOBJECT.",
        title="beschrijving",
    )
    registratiedatum: datetime = Field(
        ...,
        description="De datum waarop de behandelende organisatie het INFORMATIEOBJECT heeft geregistreerd bij het OBJECT. Geldige waardes zijn datumtijden gelegen op of voor de huidige datum en tijd.",
        title="registratiedatum",
    )
    vernietigingsdatum: Optional[datetime] = Field(
        None,
        description="De datum waarop het informatieobject uit het zaakdossier verwijderd moet worden.",
        title="vernietigingsdatum",
    )
    status: Optional[AnyUrl] = Field(
        None,
        description="De bij de desbetreffende ZAAK behorende STATUS waarvoor het ZAAK-INFORMATIEOBJECT relevant is (geweest) met het oog op het bereiken van die STATUS en/of de communicatie daarover.",
        title="status",
    )


class ZaakKenmerk(BaseModel):
    kenmerk: constr(max_length=40) = Field(
        ...,
        description="Identificeert uniek de zaak in een andere administratie.",
        title="kenmerk",
    )
    bron: constr(max_length=40) = Field(
        ...,
        description="De aanduiding van de administratie waar het kenmerk op slaat.",
        title="bron",
    )


class ZaakObject(BaseModel):
    url: AnyUrl = Field(
        ...,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: UUID = Field(..., description="Unieke resource identifier (UUID4)", title="uuid")
    zaak: AnyUrl = Field(..., description="URL-referentie naar de ZAAK.", title="zaak")
    object: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar de resource die het OBJECT beschrijft.",
        title="object",
    )
    zaakobjecttype: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar het ZAAKOBJECTTYPE (in de Catalogi API).",
        title="zaakobjecttype",
    )
    objectType: ObjectTypeEnum = Field(
        ...,
        description="Beschrijft het type OBJECT gerelateerd aan de ZAAK. Als er geen passend type is, dan moet het type worden opgegeven onder `objectTypeOverige`.\n\nUitleg bij mogelijke waarden:\n\n* `adres` - Adres\n* `besluit` - Besluit\n* `buurt` - Buurt\n* `enkelvoudig_document` - Enkelvoudig document\n* `gemeente` - Gemeente\n* `gemeentelijke_openbare_ruimte` - Gemeentelijke openbare ruimte\n* `huishouden` - Huishouden\n* `inrichtingselement` - Inrichtingselement\n* `kadastrale_onroerende_zaak` - Kadastrale onroerende zaak\n* `kunstwerkdeel` - Kunstwerkdeel\n* `maatschappelijke_activiteit` - Maatschappelijke activiteit\n* `medewerker` - Medewerker\n* `natuurlijk_persoon` - Natuurlijk persoon\n* `niet_natuurlijk_persoon` - Niet-natuurlijk persoon\n* `openbare_ruimte` - Openbare ruimte\n* `organisatorische_eenheid` - Organisatorische eenheid\n* `pand` - Pand\n* `spoorbaandeel` - Spoorbaandeel\n* `status` - Status\n* `terreindeel` - Terreindeel\n* `terrein_gebouwd_object` - Terrein gebouwd object\n* `vestiging` - Vestiging\n* `waterdeel` - Waterdeel\n* `wegdeel` - Wegdeel\n* `wijk` - Wijk\n* `woonplaats` - Woonplaats\n* `woz_deelobject` - Woz deel object\n* `woz_object` - Woz object\n* `woz_waarde` - Woz waarde\n* `zakelijk_recht` - Zakelijk recht\n* `overige` - Overige",
        title="object type",
    )
    objectTypeOverige: Optional[constr(regex=r"[a-z\_]+", max_length=100)] = Field(
        None,
        description='Beschrijft het type OBJECT als `objectType` de waarde "overige" heeft.',
        title="object type overige",
    )
    objectTypeOverigeDefinitie: Optional[ObjectTypeOverigeDefinitie] = Field(
        None,
        description='Verwijzing naar het schema van het type OBJECT als `objectType` de waarde "overige" heeft.\n\n* De URL referentie moet naar een JSON endpoint   wijzen waarin het objecttype gedefinieerd is, inclusief het   [JSON-schema](https://json-schema.org/).\n* Gebruik het `schema` attribuut om te verwijzen naar het schema binnen   de objecttype resource (deze gebruikt het   [jq](http://stedolan.github.io/jq/) formaat.\n* Gebruik het `objectData` attribuut om te verwijzen naar de gegevens   binnen het OBJECT. Deze gebruikt ook het   [jq](http://stedolan.github.io/jq/) formaat.\n\nIndien je hier gebruikt van maakt, dan moet je een OBJECT url opgeven en is het gebruik van objectIdentificatie niet mogelijk. De opgegeven OBJECT url wordt gevalideerd tegen het schema van het opgegeven objecttype.',
        title="definitie object type overige",
    )
    relatieomschrijving: Optional[constr(max_length=80)] = Field(
        None,
        description="Omschrijving van de betrekking tussen de ZAAK en het OBJECT.",
        title="relatieomschrijving",
    )


class ZaakVerzoek(BaseModel):
    url: AnyUrl = Field(
        ...,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: UUID = Field(..., description="Unieke resource identifier (UUID4)", title="uuid")
    zaak: AnyUrl = Field(..., description="URL-referentie naar de ZAAK.", title="zaak")
    verzoek: AnyUrl = Field(
        ...,
        description="URL-referentie naar het VERZOEK (in de Klantinteractie API)",
        title="verzoek",
    )


class Besluit(ZaakObject):
    pass


class BetrokkeneIdentificatieRolMedewerker(BaseModel):
    betrokkeneIdentificatie: Optional[RolMedewerker] = Field(None, title="betrokkeneIdentificatie")


class BetrokkeneIdentificatieRolOrganisatorischeEenheid(BaseModel):
    betrokkeneIdentificatie: Optional[RolOrganisatorischeEenheid] = Field(
        None, title="betrokkeneIdentificatie"
    )


class EnkelvoudigDocument(ZaakObject):
    pass


class Medewerker(Rol, BetrokkeneIdentificatieRolMedewerker):
    pass


class ObjectIdentificatieObjectAdres(BaseModel):
    objectIdentificatie: Optional[ObjectAdres] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectBuurt(BaseModel):
    objectIdentificatie: Optional[ObjectBuurt] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectGemeente(BaseModel):
    objectIdentificatie: Optional[ObjectGemeente] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectGemeentelijkeOpenbareRuimte(BaseModel):
    objectIdentificatie: Optional[ObjectGemeentelijkeOpenbareRuimte] = Field(
        None, title="objectIdentificatie"
    )


class ObjectIdentificatieObjectKadastraleOnroerendeZaak(BaseModel):
    objectIdentificatie: Optional[ObjectKadastraleOnroerendeZaak] = Field(
        None, title="objectIdentificatie"
    )


class ObjectIdentificatieObjectMaatschappelijkeActiviteit(BaseModel):
    objectIdentificatie: Optional[ObjectMaatschappelijkeActiviteit] = Field(
        None, title="objectIdentificatie"
    )


class ObjectIdentificatieObjectOpenbareRuimte(BaseModel):
    objectIdentificatie: Optional[ObjectOpenbareRuimte] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectOverige(BaseModel):
    objectIdentificatie: Optional[ObjectOverige] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectPand(BaseModel):
    objectIdentificatie: Optional[ObjectPand] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectTerreindeel(BaseModel):
    objectIdentificatie: Optional[ObjectTerreindeel] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectWegdeel(BaseModel):
    objectIdentificatie: Optional[ObjectWegdeel] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectWijk(BaseModel):
    objectIdentificatie: Optional[ObjectWijk] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectWoonplaats(BaseModel):
    objectIdentificatie: Optional[ObjectWoonplaats] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieRolMedewerker(BaseModel):
    objectIdentificatie: Optional[RolMedewerker] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieRolOrganisatorischeEenheid(BaseModel):
    objectIdentificatie: Optional[RolOrganisatorischeEenheid] = Field(
        None, title="objectIdentificatie"
    )


class OpenbareRuimte(ZaakObject, ObjectIdentificatieObjectOpenbareRuimte):
    pass


class OrganisatorischeEenheid(Rol, BetrokkeneIdentificatieRolOrganisatorischeEenheid):
    pass


class Overige(ZaakObject, ObjectIdentificatieObjectOverige):
    pass


class Pand(ZaakObject, ObjectIdentificatieObjectPand):
    pass


class Status1(ZaakObject):
    pass


class Terreindeel(ZaakObject, ObjectIdentificatieObjectTerreindeel):
    pass


class Wegdeel(ZaakObject, ObjectIdentificatieObjectWegdeel):
    pass


class Wijk(ZaakObject, ObjectIdentificatieObjectWijk):
    pass


class Woonplaats(ZaakObject, ObjectIdentificatieObjectWoonplaats):
    pass


class AuditTrail(BaseModel):
    uuid: Optional[UUID] = Field(
        None, description="Unieke identificatie van de audit regel.", title="uuid"
    )
    bron: BronEnum = Field(
        ...,
        description="De naam van het component waar de wijziging in is gedaan.\n\nUitleg bij mogelijke waarden:\n\n* `ac` - Autorisaties API\n* `nrc` - Notificaties API\n* `zrc` - Zaken API\n* `ztc` - Catalogi API\n* `drc` - Documenten API\n* `brc` - Besluiten API\n* `cmc` - Contactmomenten API\n* `kc` - Klanten API\n* `vrc` - Verzoeken API",
        title="bron",
    )
    applicatieId: Optional[constr(max_length=100)] = Field(
        None,
        description="Unieke identificatie van de applicatie, binnen de organisatie.",
        title="applicatie id",
    )
    applicatieWeergave: Optional[constr(max_length=200)] = Field(
        None, description="Vriendelijke naam van de applicatie.", title="applicatie weergave"
    )
    gebruikersId: Optional[constr(max_length=255)] = Field(
        None,
        description="Unieke identificatie van de gebruiker die binnen de organisatie herleid kan worden naar een persoon.",
        title="gebruikers id",
    )
    gebruikersWeergave: Optional[constr(max_length=255)] = Field(
        None, description="Vriendelijke naam van de gebruiker.", title="gebruikers weergave"
    )
    actie: constr(max_length=50) = Field(
        ...,
        description="De uitgevoerde handeling.\n\nDe bekende waardes voor dit veld zijn hieronder aangegeven,                         maar andere waardes zijn ook toegestaan\n\nUitleg bij mogelijke waarden:\n\n* `create` - Object aangemaakt\n* `list` - Lijst van objecten opgehaald\n* `retrieve` - Object opgehaald\n* `destroy` - Object verwijderd\n* `update` - Object bijgewerkt\n* `partial_update` - Object deels bijgewerkt",
        title="actie",
    )
    actieWeergave: Optional[constr(max_length=200)] = Field(
        None, description="Vriendelijke naam van de actie.", title="actie weergave"
    )
    resultaat: conint(ge=100, le=599) = Field(
        ...,
        description="HTTP status code van de API response van de uitgevoerde handeling.",
        title="resultaat",
    )
    hoofdObject: AnyUrl = Field(
        ..., description="De URL naar het hoofdobject van een component.", title="hoofd object"
    )
    resource: constr(max_length=50) = Field(
        ..., description="Het type resource waarop de actie gebeurde.", title="resource"
    )
    resourceUrl: AnyUrl = Field(..., description="De URL naar het object.", title="resource url")
    toelichting: Optional[str] = Field(
        None, description="Toelichting waarom de handeling is uitgevoerd.", title="toelichting"
    )
    resourceWeergave: constr(max_length=200) = Field(
        ..., description="Vriendelijke identificatie van het object.", title="resource weergave"
    )
    aanmaakdatum: datetime = Field(
        ..., description="De datum waarop de handeling is gedaan.", title="aanmaakdatum"
    )
    wijzigingen: Wijzigingen = Field(..., title="wijzigingen")


class Geometry(BaseModel):
    type: GeometryTypeEnum = Field(..., description="The geometry type")


class GeometryCollection(Geometry):
    geometries: List[Geometry]


class LineString(Geometry):
    coordinates: List[Point2D] = Field(..., min_items=2)


class MultiLineString(Geometry):
    coordinates: List[List[Point2D]]


class MultiPoint(Geometry):
    coordinates: List[Point2D]


class MultiPolygon(Geometry):
    coordinates: List[List[List[Point2D]]]


class ObjectInrichtingselement(BaseModel):
    type: ObjectInrichtingselementTypeEnum = Field(
        ...,
        description="Specificatie van de aard van het inrichtingselement.\n\nUitleg bij mogelijke waarden:\n\n* `bak` - Bak\n* `bord` - Bord\n* `installatie` - Installatie\n* `kast` - Kast\n* `mast` - Mast\n* `paal` - Paal\n* `sensor` - Sensor\n* `straatmeubilair` - Straatmeubilair\n* `waterinrichtingselement` - Waterinrichtingselement\n* `weginrichtingselement` - Weginrichtingselement",
        title="type",
    )
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    naam: Optional[constr(max_length=500)] = Field(
        None, description="De benaming van het OBJECT", title="naam"
    )


class ObjectKunstwerkdeel(BaseModel):
    type: ObjectKunstwerkdeelTypeEnum = Field(
        ...,
        description="Specificatie van het soort Kunstwerk waartoe het kunstwerkdeel behoort.\n\nUitleg bij mogelijke waarden:\n\n* `keermuur` - Keermuur\n* `overkluizing` - Overkluizing\n* `duiker` - Duiker\n* `faunavoorziening` - Faunavoorziening\n* `vispassage` - Vispassage\n* `bodemval` - Bodemval\n* `coupure` - Coupure\n* `ponton` - Ponton\n* `voorde` - Voorde\n* `hoogspanningsmast` - Hoogspanningsmast\n* `gemaal` - Gemaal\n* `perron` - Perron\n* `sluis` - Sluis\n* `strekdam` - Strekdam\n* `steiger` - Steiger\n* `stuw` - Stuw",
        title="type",
    )
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    naam: constr(max_length=80) = Field(..., title="naam")


class ObjectSpoorbaandeel(BaseModel):
    type: ObjectSpoorbaandeelTypeEnum = Field(
        ...,
        description="Specificatie van het soort Spoorbaan\n\nUitleg bij mogelijke waarden:\n\n* `breedspoor` - breedspoor\n* `normaalspoor` - normaalspoor\n* `smalspoor` - smalspoor\n* `spoorbaan` - spoorbaan",
        title="type",
    )
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    naam: Optional[constr(max_length=500)] = Field(
        None, description="De benaming van het OBJECT", title="naam"
    )


class ObjectTerreinGebouwdObject(BaseModel):
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    adresAanduidingGrp: Optional[TerreinGebouwdObjectAdres] = Field(
        None, title="adresAanduidingGrp"
    )


class ObjectWaterdeel(BaseModel):
    typeWaterdeel: TypeWaterdeelEnum = Field(
        ...,
        description="Specificatie van het soort water\n\nUitleg bij mogelijke waarden:\n\n* `zee` - Zee\n* `waterloop` - Waterloop\n* `watervlakte` - Watervlakte\n* `greppel_droge_sloot` - Greppel, droge sloot",
        title="type waterdeel",
    )
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    naam: Optional[constr(max_length=500)] = Field(
        None, description="De benaming van het OBJECT", title="naam"
    )


class ObjectWozObject(BaseModel):
    wozObjectNummer: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="woz object nummer"
    )
    aanduidingWozObject: Optional[WozObjectAdres] = Field(None, title="aanduidingWozObject")


class ObjectWozWaarde(BaseModel):
    waardepeildatum: constr(max_length=9) = Field(
        ...,
        description="De datum waarnaar de waarde van het WOZ-object wordt bepaald.",
        title="waardepeildatum",
    )
    isVoor: Optional[ObjectWozObject] = Field(None, title="isVoor")


class PaginatedResultaatList(BaseModel):
    count: Optional[int] = Field(None, example=123)
    next: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=4")
    previous: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=2")
    results: Optional[List[Resultaat]] = None


class PaginatedRolList(BaseModel):
    count: Optional[int] = Field(None, example=123)
    next: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=4")
    previous: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=2")
    results: Optional[List[Rol]] = None


class PaginatedStatusList(BaseModel):
    count: Optional[int] = Field(None, example=123)
    next: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=4")
    previous: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=2")
    results: Optional[List[Status]] = None


class PaginatedZaakObjectList(BaseModel):
    count: Optional[int] = Field(None, example=123)
    next: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=4")
    previous: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=2")
    results: Optional[List[ZaakObject]] = None


class Point(Geometry):
    coordinates: Point2D


class Polygon(Geometry):
    coordinates: List[List[Point2D]]


class RolNatuurlijkPersoon(BaseModel):
    inpBsn: Optional[constr(max_length=9)] = Field(
        None,
        description="Het burgerservicenummer, bedoeld in artikel 1.1 van de Wet algemene bepalingen burgerservicenummer.",
        title="inp bsn",
    )
    anpIdentificatie: Optional[constr(max_length=17)] = Field(
        None,
        description="Het door de gemeente uitgegeven unieke nummer voor een ANDER NATUURLIJK PERSOON",
        title="anp identificatie",
    )
    inpA_nummer: Optional[constr(regex=r"^[1-9][0-9]{9}$", max_length=10)] = Field(
        None,
        description="Het administratienummer van de persoon, bedoeld in de Wet BRP",
        title="inp a nummer",
    )
    geslachtsnaam: Optional[constr(max_length=200)] = Field(
        None, description="De stam van de geslachtsnaam.", title="geslachtsnaam"
    )
    voorvoegselGeslachtsnaam: Optional[constr(max_length=80)] = Field(
        None, title="voorvoegsel geslachtsnaam"
    )
    voorletters: Optional[constr(max_length=20)] = Field(
        None,
        description="De verzameling letters die gevormd wordt door de eerste letter van alle in volgorde voorkomende voornamen.",
        title="voorletters",
    )
    voornamen: Optional[constr(max_length=200)] = Field(
        None,
        description="Voornamen bij de naam die de persoon wenst te voeren.",
        title="voornamen",
    )
    geslachtsaanduiding: Optional[Union[GeslachtsaanduidingEnum, BlankEnum]] = Field(
        None,
        description="Een aanduiding die aangeeft of de persoon een man of een vrouw is, of dat het geslacht nog onbekend is.\n\nUitleg bij mogelijke waarden:\n\n* `m` - Man\n* `v` - Vrouw\n* `o` - Onbekend",
        title="geslachtsaanduiding",
    )
    geboortedatum: Optional[constr(max_length=18)] = Field(None, title="geboortedatum")
    verblijfsadres: Optional[VerblijfsAdres] = Field(None, title="verblijfsadres")
    subVerblijfBuitenland: Optional[SubVerblijfBuitenland] = Field(
        None, title="subVerblijfBuitenland"
    )


class RolNietNatuurlijkPersoon(BaseModel):
    innNnpId: Optional[constr(max_length=9)] = Field(
        None,
        description="Het door een kamer toegekend uniek nummer voor de INGESCHREVEN NIET-NATUURLIJK PERSOON",
        title="inn nnp id",
    )
    annIdentificatie: Optional[constr(max_length=17)] = Field(
        None,
        description="Het door de gemeente uitgegeven unieke nummer voor een ANDER NIET-NATUURLIJK PERSOON",
        title="ann identificatie",
    )
    statutaireNaam: Optional[constr(max_length=500)] = Field(
        None,
        description="Naam van de niet-natuurlijke persoon zoals deze is vastgelegd in de statuten (rechtspersoon) of in de vennootschapsovereenkomst is overeengekomen (Vennootschap onder firma of Commanditaire vennootschap).",
        title="statutaire naam",
    )
    innRechtsvorm: Optional[Union[InnRechtsvormEnum, BlankEnum]] = Field(
        None,
        description="De juridische vorm van de NIET-NATUURLIJK PERSOON.",
        title="inn rechtsvorm",
    )
    bezoekadres: Optional[constr(max_length=1000)] = Field(
        None,
        description="De gegevens over het adres van de NIET-NATUURLIJK PERSOON",
        title="bezoekadres",
    )
    subVerblijfBuitenland: Optional[SubVerblijfBuitenland] = Field(
        None, title="subVerblijfBuitenland"
    )


class RolVestiging(BaseModel):
    vestigingsNummer: Optional[constr(max_length=24)] = Field(
        None,
        description="Een korte unieke aanduiding van de Vestiging.",
        title="vestigings nummer",
    )
    handelsnaam: Optional[List[constr(max_length=625)]] = Field(
        None,
        description="De naam van de vestiging waaronder gehandeld wordt.",
        title="handelsnaam",
    )
    verblijfsadres: Optional[VerblijfsAdres] = Field(None, title="verblijfsadres")
    subVerblijfBuitenland: Optional[SubVerblijfBuitenland] = Field(
        None, title="subVerblijfBuitenland"
    )


class ZakelijkRechtHeeftAlsGerechtigde(BaseModel):
    natuurlijkPersoon: Optional[RolNatuurlijkPersoon] = Field(None, title="natuurlijkPersoon")
    nietNatuurlijkPersoon: Optional[RolNietNatuurlijkPersoon] = Field(
        None, title="nietNatuurlijkPersoon"
    )


class Adres(ZaakObject, ObjectIdentificatieObjectAdres):
    pass


class BetrokkeneIdentificatieRolNatuurlijkPersoon(BaseModel):
    betrokkeneIdentificatie: Optional[RolNatuurlijkPersoon] = Field(
        None, title="betrokkeneIdentificatie"
    )


class BetrokkeneIdentificatieRolNietNatuurlijkPersoon(BaseModel):
    betrokkeneIdentificatie: Optional[RolNietNatuurlijkPersoon] = Field(
        None, title="betrokkeneIdentificatie"
    )


class BetrokkeneIdentificatieRolVestiging(BaseModel):
    betrokkeneIdentificatie: Optional[RolVestiging] = Field(None, title="betrokkeneIdentificatie")


class Buurt(ZaakObject, ObjectIdentificatieObjectBuurt):
    pass


class Gemeente(ZaakObject, ObjectIdentificatieObjectGemeente):
    pass


class GemeentelijkeOpenbareRuimte(
    ZaakObject, ObjectIdentificatieObjectGemeentelijkeOpenbareRuimte
):
    pass


class KadastraleOnroerendeZaak(ZaakObject, ObjectIdentificatieObjectKadastraleOnroerendeZaak):
    pass


class MaatschappelijkeActiviteit(ZaakObject, ObjectIdentificatieObjectMaatschappelijkeActiviteit):
    pass


class NatuurlijkPersoon1(Rol, BetrokkeneIdentificatieRolNatuurlijkPersoon):
    pass


class NietNatuurlijkPersoon1(Rol, BetrokkeneIdentificatieRolNietNatuurlijkPersoon):
    pass


class ObjectIdentificatieObjectInrichtingselement(BaseModel):
    objectIdentificatie: Optional[ObjectInrichtingselement] = Field(
        None, title="objectIdentificatie"
    )


class ObjectIdentificatieObjectKunstwerkdeel(BaseModel):
    objectIdentificatie: Optional[ObjectKunstwerkdeel] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectSpoorbaandeel(BaseModel):
    objectIdentificatie: Optional[ObjectSpoorbaandeel] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectTerreinGebouwdObject(BaseModel):
    objectIdentificatie: Optional[ObjectTerreinGebouwdObject] = Field(
        None, title="objectIdentificatie"
    )


class ObjectIdentificatieObjectWaterdeel(BaseModel):
    objectIdentificatie: Optional[ObjectWaterdeel] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectWozObject(BaseModel):
    objectIdentificatie: Optional[ObjectWozObject] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectWozWaarde(BaseModel):
    objectIdentificatie: Optional[ObjectWozWaarde] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieRolNatuurlijkPersoon(BaseModel):
    objectIdentificatie: Optional[RolNatuurlijkPersoon] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieRolNietNatuurlijkPersoon(BaseModel):
    objectIdentificatie: Optional[RolNietNatuurlijkPersoon] = Field(
        None, title="objectIdentificatie"
    )


class ObjectIdentificatieRolVestiging(BaseModel):
    objectIdentificatie: Optional[RolVestiging] = Field(None, title="objectIdentificatie")


class Spoorbaandeel(ZaakObject, ObjectIdentificatieObjectSpoorbaandeel):
    pass


class TerreinGebouwdObject(ZaakObject, ObjectIdentificatieObjectTerreinGebouwdObject):
    pass


class Vestiging(Rol, BetrokkeneIdentificatieRolVestiging):
    pass


class Waterdeel(ZaakObject, ObjectIdentificatieObjectWaterdeel):
    pass


class WozObject(ZaakObject, ObjectIdentificatieObjectWozObject):
    pass


class WozWaarde(ZaakObject, ObjectIdentificatieObjectWozWaarde):
    pass


class GeoJSONGeometry(BaseModel):
    __root__: Union[
        Point, MultiPoint, LineString, MultiLineString, Polygon, MultiPolygon, GeometryCollection
    ] = Field(..., title="GeoJSONGeometry")


class GeoWithin(BaseModel):
    within: Optional[GeoJSONGeometry] = Field(None, title="within")


class ObjectHuishouden(BaseModel):
    nummer: constr(max_length=12) = Field(
        ...,
        description="Uniek identificerend administratienummer van een huishouden zoals toegekend door de gemeente waarin het huishouden woonachtig is.",
        title="nummer",
    )
    isGehuisvestIn: Optional[ObjectTerreinGebouwdObject] = Field(None, title="isGehuisvestIn")


class ObjectWozDeelobject(BaseModel):
    nummerWozDeelObject: constr(max_length=6) = Field(
        ...,
        description="Uniek identificatienummer voor het deelobject binnen een WOZ-object.",
        title="nummer woz deel object",
    )
    isOnderdeelVan: Optional[ObjectWozObject] = Field(None, title="isOnderdeelVan")


class ObjectZakelijkRecht(BaseModel):
    identificatie: constr(max_length=100) = Field(
        ..., description="De unieke identificatie van het OBJECT", title="identificatie"
    )
    avgAard: constr(max_length=1000) = Field(
        ..., description="aanduiding voor de aard van het recht", title="avg aard"
    )
    heeftBetrekkingOp: Optional[ObjectKadastraleOnroerendeZaak] = Field(
        None, title="heeftBetrekkingOp"
    )
    heeftAlsGerechtigde: Optional[ZakelijkRechtHeeftAlsGerechtigde] = Field(
        None, title="heeftAlsGerechtigde"
    )


class PatchedZaak(BaseModel):
    url: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: Optional[UUID] = Field(
        None, description="Unieke resource identifier (UUID4)", title="uuid"
    )
    identificatie: Optional[constr(max_length=40)] = Field(
        None,
        description="De unieke identificatie van de ZAAK binnen de organisatie die verantwoordelijk is voor de behandeling van de ZAAK.",
        title="identificatie",
    )
    bronorganisatie: Optional[constr(max_length=9)] = Field(
        None,
        description="Het RSIN van de Niet-natuurlijk persoon zijnde de organisatie die de zaak heeft gecreeerd. Dit moet een geldig RSIN zijn van 9 nummers en voldoen aan https://nl.wikipedia.org/wiki/Burgerservicenummer#11-proef",
        title="bronorganisatie",
    )
    omschrijving: Optional[constr(max_length=80)] = Field(
        None, description="Een korte omschrijving van de zaak.", title="omschrijving"
    )
    toelichting: Optional[constr(max_length=1000)] = Field(
        None, description="Een toelichting op de zaak.", title="toelichting"
    )
    zaaktype: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar het ZAAKTYPE (in de Catalogi API) in de CATALOGUS waar deze voorkomt",
        title="zaaktype",
    )
    registratiedatum: Optional[date] = Field(
        None,
        description="De datum waarop de zaakbehandelende organisatie de ZAAK heeft geregistreerd. Indien deze niet opgegeven wordt, wordt de datum van vandaag gebruikt.",
        title="registratiedatum",
    )
    verantwoordelijkeOrganisatie: Optional[constr(max_length=9)] = Field(
        None,
        description="Het RSIN van de Niet-natuurlijk persoon zijnde de organisatie die eindverantwoordelijk is voor de behandeling van de zaak. Dit moet een geldig RSIN zijn van 9 nummers en voldoen aan https://nl.wikipedia.org/wiki/Burgerservicenummer#11-proef",
        title="verantwoordelijke organisatie",
    )
    startdatum: Optional[date] = Field(
        None,
        description="De datum waarop met de uitvoering van de zaak is gestart",
        title="startdatum",
    )
    einddatum: Optional[date] = Field(
        None,
        description="De datum waarop de uitvoering van de zaak afgerond is.",
        title="einddatum",
    )
    einddatumGepland: Optional[date] = Field(
        None,
        description="De datum waarop volgens de planning verwacht wordt dat de zaak afgerond wordt.",
        title="einddatum gepland",
    )
    uiterlijkeEinddatumAfdoening: Optional[date] = Field(
        None,
        description="De laatste datum waarop volgens wet- en regelgeving de zaak afgerond dient te zijn.",
        title="uiterlijke einddatum afdoening",
    )
    publicatiedatum: Optional[date] = Field(
        None,
        description="Datum waarop (het starten van) de zaak gepubliceerd is of wordt.",
        title="publicatiedatum",
    )
    communicatiekanaal: Optional[AnyUrl] = Field(
        None,
        description="Het medium waarlangs de aanleiding om een zaak te starten is ontvangen. URL naar een communicatiekanaal in de VNG-Referentielijst van communicatiekanalen.",
        title="communicatiekanaal",
    )
    productenOfDiensten: Optional[List[AnyUrl]] = Field(
        None,
        description="De producten en/of diensten die door de zaak worden voortgebracht. Dit zijn URLs naar de resources zoals die door de producten- en dienstencatalogus-API wordt ontsloten. De producten/diensten moeten bij het zaaktype vermeld zijn.",
        title="producten of diensten",
    )
    vertrouwelijkheidaanduiding: Optional[VertrouwelijkheidaanduidingEnum] = Field(
        None,
        description="Aanduiding van de mate waarin het zaakdossier van de ZAAK voor de openbaarheid bestemd is. Optioneel - indien geen waarde gekozen wordt, dan wordt de waarde van het ZAAKTYPE overgenomen. Dit betekent dat de API _altijd_ een waarde teruggeeft.",
        title="Vertrouwlijkheidaanduiding",
    )
    betalingsindicatie: Optional[Union[BetalingsindicatieEnum, BlankEnum]] = Field(
        None,
        description="Indicatie of de, met behandeling van de zaak gemoeide, kosten betaald zijn door de desbetreffende betrokkene.\n\nUitleg bij mogelijke waarden:\n\n* `nvt` - Er is geen sprake van te betalen, met de zaak gemoeide, kosten.\n* `nog_niet` - De met de zaak gemoeide kosten zijn (nog) niet betaald.\n* `gedeeltelijk` - De met de zaak gemoeide kosten zijn gedeeltelijk betaald.\n* `geheel` - De met de zaak gemoeide kosten zijn geheel betaald.",
        title="betalingsindicatie",
    )
    betalingsindicatieWeergave: Optional[str] = Field(
        None, description="Uitleg bij `betalingsindicatie`.", title="betalingsindicatieWeergave"
    )
    laatsteBetaaldatum: Optional[datetime] = Field(
        None,
        description="De datum waarop de meest recente betaling is verwerkt van kosten die gemoeid zijn met behandeling van de zaak.",
        title="laatste betaaldatum",
    )
    zaakgeometrie: Optional[GeoJSONGeometry] = Field(
        None,
        description="Punt, lijn of (multi-)vlak geometrie-informatie, in GeoJSON.",
        title="zaakgeometrie",
    )
    verlenging: Optional[Verlenging] = Field(
        None,
        description="Gegevens omtrent het verlengen van de doorlooptijd van de behandeling van de ZAAK",
        title="verlenging",
    )
    opschorting: Optional[Opschorting] = Field(
        None,
        description="Gegevens omtrent het tijdelijk opschorten van de behandeling van de ZAAK",
        title="opschorting",
    )
    selectielijstklasse: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar de categorie in de gehanteerde 'Selectielijst Archiefbescheiden' die, gezien het zaaktype en het resultaattype van de zaak, bepalend is voor het archiefregime van de zaak.",
        title="selectielijstklasse",
    )
    hoofdzaak: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar de ZAAK, waarom verzocht is door de initiator daarvan, die behandeld wordt in twee of meer separate ZAAKen waarvan de onderhavige ZAAK er één is.",
        title="Is deelzaak van",
    )
    deelzaken: Optional[List[AnyUrl]] = Field(
        None,
        description="URL-referenties naar deel ZAAKen.",
        title="is deelzaak van",
        unique_items=True,
    )
    relevanteAndereZaken: Optional[List[RelevanteZaak]] = Field(
        None, description="Een lijst van relevante andere zaken.", title="zaak"
    )
    eigenschappen: Optional[List[AnyUrl]] = Field(None, title="zaak", unique_items=True)
    rollen: Optional[List[AnyUrl]] = Field(None, title="zaak", unique_items=True)
    status: Optional[AnyUrl] = Field(
        None, description="Indien geen status bekend is, dan is de waarde 'null'", title="status"
    )
    zaakinformatieobjecten: Optional[List[AnyUrl]] = Field(None, title="zaak", unique_items=True)
    zaakobjecten: Optional[List[AnyUrl]] = Field(None, title="zaak", unique_items=True)
    kenmerken: Optional[List[ZaakKenmerk]] = Field(
        None,
        description="Lijst van kenmerken. Merk op dat refereren naar gerelateerde objecten beter kan via `ZaakObject`.",
        title="zaak",
    )
    archiefnominatie: Optional[Union[ArchiefnominatieEnum, BlankEnum, NullEnum]] = Field(
        None,
        description="Aanduiding of het zaakdossier blijvend bewaard of na een bepaalde termijn vernietigd moet worden.\n\nUitleg bij mogelijke waarden:\n\n* `blijvend_bewaren` - Het zaakdossier moet bewaard blijven en op de Archiefactiedatum overgedragen worden naar een archiefbewaarplaats.\n* `vernietigen` - Het zaakdossier moet op of na de Archiefactiedatum vernietigd worden.",
        title="archiefnominatie",
    )
    archiefstatus: Optional[ArchiefstatusEnum] = Field(
        None,
        description="Aanduiding of het zaakdossier blijvend bewaard of na een bepaalde termijn vernietigd moet worden.\n\nUitleg bij mogelijke waarden:\n\n* `nog_te_archiveren` - De zaak cq. het zaakdossier is nog niet als geheel gearchiveerd.\n* `gearchiveerd` - De zaak cq. het zaakdossier is als geheel niet-wijzigbaar bewaarbaar gemaakt.\n* `gearchiveerd_procestermijn_onbekend` - De zaak cq. het zaakdossier is als geheel niet-wijzigbaar bewaarbaar gemaakt maar de vernietigingsdatum kan nog niet bepaald worden.\n* `overgedragen` - De zaak cq. het zaakdossier is overgebracht naar een archiefbewaarplaats.",
        title="archiefstatus",
    )
    archiefactiedatum: Optional[date] = Field(
        None,
        description="De datum waarop het gearchiveerde zaakdossier vernietigd moet worden dan wel overgebracht moet worden naar een archiefbewaarplaats. Wordt automatisch berekend bij het aanmaken of wijzigen van een RESULTAAT aan deze ZAAK indien nog leeg.",
        title="archiefactiedatum",
    )
    resultaat: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar het RESULTAAT. Indien geen resultaat bekend is, dan is de waarde 'null'",
        title="resultaat",
    )
    opdrachtgevendeOrganisatie: Optional[constr(max_length=9)] = Field(
        None,
        description="De krachtens publiekrecht ingestelde rechtspersoon dan wel ander niet-natuurlijk persoon waarbinnen het (bestuurs)orgaan zetelt dat opdracht heeft gegeven om taken uit te voeren waaraan de zaak invulling geeft.",
        title="opdrachtgevende organisatie",
    )
    processobjectaard: Optional[constr(max_length=200)] = Field(
        None,
        description="Omschrijving van het object, subject of gebeurtenis waarop, vanuit archiveringsoptiek, de zaak betrekking heeft.",
        title="Procesobjectaard",
    )
    resultaattoelichting: Optional[constr(max_length=1000)] = Field(
        None,
        description="Een toelichting op wat het resultaat van de zaak inhoudt.",
        title="resultaattoelichting",
    )
    startdatumBewaartermijn: Optional[date] = Field(
        None,
        description="De datum die de start markeert van de termijn waarop het zaakdossier vernietigd moet worden.",
        title="startdatum bewaartermijn",
    )
    processobject: Optional[Processobject] = Field(
        None,
        description="Specificatie van de attribuutsoort van het object, subject of gebeurtenis  waarop, vanuit archiveringsoptiek, de zaak betrekking heeft en dat bepalend is voor de start van de archiefactietermijn.",
        title="processobject",
    )


class Zaak(BaseModel):
    url: AnyUrl = Field(
        ...,
        description="URL-referentie naar dit object. Dit is de unieke identificatie en locatie van dit object.",
        title="url",
    )
    uuid: UUID = Field(..., description="Unieke resource identifier (UUID4)", title="uuid")
    identificatie: Optional[constr(max_length=40)] = Field(
        None,
        description="De unieke identificatie van de ZAAK binnen de organisatie die verantwoordelijk is voor de behandeling van de ZAAK.",
        title="identificatie",
    )
    bronorganisatie: constr(max_length=9) = Field(
        ...,
        description="Het RSIN van de Niet-natuurlijk persoon zijnde de organisatie die de zaak heeft gecreeerd. Dit moet een geldig RSIN zijn van 9 nummers en voldoen aan https://nl.wikipedia.org/wiki/Burgerservicenummer#11-proef",
        title="bronorganisatie",
    )
    omschrijving: Optional[constr(max_length=80)] = Field(
        None, description="Een korte omschrijving van de zaak.", title="omschrijving"
    )
    toelichting: Optional[constr(max_length=1000)] = Field(
        None, description="Een toelichting op de zaak.", title="toelichting"
    )
    zaaktype: AnyUrl = Field(
        ...,
        description="URL-referentie naar het ZAAKTYPE (in de Catalogi API) in de CATALOGUS waar deze voorkomt",
        title="zaaktype",
    )
    registratiedatum: Optional[date] = Field(
        None,
        description="De datum waarop de zaakbehandelende organisatie de ZAAK heeft geregistreerd. Indien deze niet opgegeven wordt, wordt de datum van vandaag gebruikt.",
        title="registratiedatum",
    )
    verantwoordelijkeOrganisatie: constr(max_length=9) = Field(
        ...,
        description="Het RSIN van de Niet-natuurlijk persoon zijnde de organisatie die eindverantwoordelijk is voor de behandeling van de zaak. Dit moet een geldig RSIN zijn van 9 nummers en voldoen aan https://nl.wikipedia.org/wiki/Burgerservicenummer#11-proef",
        title="verantwoordelijke organisatie",
    )
    startdatum: date = Field(
        ...,
        description="De datum waarop met de uitvoering van de zaak is gestart",
        title="startdatum",
    )
    einddatum: date = Field(
        ...,
        description="De datum waarop de uitvoering van de zaak afgerond is.",
        title="einddatum",
    )
    einddatumGepland: Optional[date] = Field(
        None,
        description="De datum waarop volgens de planning verwacht wordt dat de zaak afgerond wordt.",
        title="einddatum gepland",
    )
    uiterlijkeEinddatumAfdoening: Optional[date] = Field(
        None,
        description="De laatste datum waarop volgens wet- en regelgeving de zaak afgerond dient te zijn.",
        title="uiterlijke einddatum afdoening",
    )
    publicatiedatum: Optional[date] = Field(
        None,
        description="Datum waarop (het starten van) de zaak gepubliceerd is of wordt.",
        title="publicatiedatum",
    )
    communicatiekanaal: Optional[AnyUrl] = Field(
        None,
        description="Het medium waarlangs de aanleiding om een zaak te starten is ontvangen. URL naar een communicatiekanaal in de VNG-Referentielijst van communicatiekanalen.",
        title="communicatiekanaal",
    )
    productenOfDiensten: Optional[List[AnyUrl]] = Field(
        None,
        description="De producten en/of diensten die door de zaak worden voortgebracht. Dit zijn URLs naar de resources zoals die door de producten- en dienstencatalogus-API wordt ontsloten. De producten/diensten moeten bij het zaaktype vermeld zijn.",
        title="producten of diensten",
    )
    vertrouwelijkheidaanduiding: Optional[VertrouwelijkheidaanduidingEnum] = Field(
        None,
        description="Aanduiding van de mate waarin het zaakdossier van de ZAAK voor de openbaarheid bestemd is. Optioneel - indien geen waarde gekozen wordt, dan wordt de waarde van het ZAAKTYPE overgenomen. Dit betekent dat de API _altijd_ een waarde teruggeeft.",
        title="Vertrouwlijkheidaanduiding",
    )
    betalingsindicatie: Optional[Union[BetalingsindicatieEnum, BlankEnum]] = Field(
        None,
        description="Indicatie of de, met behandeling van de zaak gemoeide, kosten betaald zijn door de desbetreffende betrokkene.\n\nUitleg bij mogelijke waarden:\n\n* `nvt` - Er is geen sprake van te betalen, met de zaak gemoeide, kosten.\n* `nog_niet` - De met de zaak gemoeide kosten zijn (nog) niet betaald.\n* `gedeeltelijk` - De met de zaak gemoeide kosten zijn gedeeltelijk betaald.\n* `geheel` - De met de zaak gemoeide kosten zijn geheel betaald.",
        title="betalingsindicatie",
    )
    betalingsindicatieWeergave: str = Field(
        ..., description="Uitleg bij `betalingsindicatie`.", title="betalingsindicatieWeergave"
    )
    laatsteBetaaldatum: Optional[datetime] = Field(
        None,
        description="De datum waarop de meest recente betaling is verwerkt van kosten die gemoeid zijn met behandeling van de zaak.",
        title="laatste betaaldatum",
    )
    zaakgeometrie: Optional[GeoJSONGeometry] = Field(
        None,
        description="Punt, lijn of (multi-)vlak geometrie-informatie, in GeoJSON.",
        title="zaakgeometrie",
    )
    verlenging: Optional[Verlenging] = Field(
        None,
        description="Gegevens omtrent het verlengen van de doorlooptijd van de behandeling van de ZAAK",
        title="verlenging",
    )
    opschorting: Optional[Opschorting] = Field(
        None,
        description="Gegevens omtrent het tijdelijk opschorten van de behandeling van de ZAAK",
        title="opschorting",
    )
    selectielijstklasse: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar de categorie in de gehanteerde 'Selectielijst Archiefbescheiden' die, gezien het zaaktype en het resultaattype van de zaak, bepalend is voor het archiefregime van de zaak.",
        title="selectielijstklasse",
    )
    hoofdzaak: Optional[AnyUrl] = Field(
        None,
        description="URL-referentie naar de ZAAK, waarom verzocht is door de initiator daarvan, die behandeld wordt in twee of meer separate ZAAKen waarvan de onderhavige ZAAK er één is.",
        title="Is deelzaak van",
    )
    deelzaken: List[AnyUrl] = Field(
        ...,
        description="URL-referenties naar deel ZAAKen.",
        title="is deelzaak van",
        unique_items=True,
    )
    relevanteAndereZaken: Optional[List[RelevanteZaak]] = Field(
        None, description="Een lijst van relevante andere zaken.", title="zaak"
    )
    eigenschappen: List[AnyUrl] = Field(..., title="zaak", unique_items=True)
    rollen: List[AnyUrl] = Field(..., title="zaak", unique_items=True)
    status: AnyUrl = Field(
        ..., description="Indien geen status bekend is, dan is de waarde 'null'", title="status"
    )
    zaakinformatieobjecten: List[AnyUrl] = Field(..., title="zaak", unique_items=True)
    zaakobjecten: List[AnyUrl] = Field(..., title="zaak", unique_items=True)
    kenmerken: Optional[List[ZaakKenmerk]] = Field(
        None,
        description="Lijst van kenmerken. Merk op dat refereren naar gerelateerde objecten beter kan via `ZaakObject`.",
        title="zaak",
    )
    archiefnominatie: Optional[Union[ArchiefnominatieEnum, BlankEnum, NullEnum]] = Field(
        None,
        description="Aanduiding of het zaakdossier blijvend bewaard of na een bepaalde termijn vernietigd moet worden.\n\nUitleg bij mogelijke waarden:\n\n* `blijvend_bewaren` - Het zaakdossier moet bewaard blijven en op de Archiefactiedatum overgedragen worden naar een archiefbewaarplaats.\n* `vernietigen` - Het zaakdossier moet op of na de Archiefactiedatum vernietigd worden.",
        title="archiefnominatie",
    )
    archiefstatus: Optional[ArchiefstatusEnum] = Field(
        None,
        description="Aanduiding of het zaakdossier blijvend bewaard of na een bepaalde termijn vernietigd moet worden.\n\nUitleg bij mogelijke waarden:\n\n* `nog_te_archiveren` - De zaak cq. het zaakdossier is nog niet als geheel gearchiveerd.\n* `gearchiveerd` - De zaak cq. het zaakdossier is als geheel niet-wijzigbaar bewaarbaar gemaakt.\n* `gearchiveerd_procestermijn_onbekend` - De zaak cq. het zaakdossier is als geheel niet-wijzigbaar bewaarbaar gemaakt maar de vernietigingsdatum kan nog niet bepaald worden.\n* `overgedragen` - De zaak cq. het zaakdossier is overgebracht naar een archiefbewaarplaats.",
        title="archiefstatus",
    )
    archiefactiedatum: Optional[date] = Field(
        None,
        description="De datum waarop het gearchiveerde zaakdossier vernietigd moet worden dan wel overgebracht moet worden naar een archiefbewaarplaats. Wordt automatisch berekend bij het aanmaken of wijzigen van een RESULTAAT aan deze ZAAK indien nog leeg.",
        title="archiefactiedatum",
    )
    resultaat: AnyUrl = Field(
        ...,
        description="URL-referentie naar het RESULTAAT. Indien geen resultaat bekend is, dan is de waarde 'null'",
        title="resultaat",
    )
    opdrachtgevendeOrganisatie: Optional[constr(max_length=9)] = Field(
        None,
        description="De krachtens publiekrecht ingestelde rechtspersoon dan wel ander niet-natuurlijk persoon waarbinnen het (bestuurs)orgaan zetelt dat opdracht heeft gegeven om taken uit te voeren waaraan de zaak invulling geeft.",
        title="opdrachtgevende organisatie",
    )
    processobjectaard: Optional[constr(max_length=200)] = Field(
        None,
        description="Omschrijving van het object, subject of gebeurtenis waarop, vanuit archiveringsoptiek, de zaak betrekking heeft.",
        title="Procesobjectaard",
    )
    resultaattoelichting: Optional[constr(max_length=1000)] = Field(
        None,
        description="Een toelichting op wat het resultaat van de zaak inhoudt.",
        title="resultaattoelichting",
    )
    startdatumBewaartermijn: Optional[date] = Field(
        None,
        description="De datum die de start markeert van de termijn waarop het zaakdossier vernietigd moet worden.",
        title="startdatum bewaartermijn",
    )
    processobject: Optional[Processobject] = Field(
        None,
        description="Specificatie van de attribuutsoort van het object, subject of gebeurtenis  waarop, vanuit archiveringsoptiek, de zaak betrekking heeft en dat bepalend is voor de start van de archiefactietermijn.",
        title="processobject",
    )


class ZaakZoek(BaseModel):
    zaakgeometrie: Optional[GeoWithin] = Field(None, title="zaakgeometrie")
    uuid__in: Optional[List[UUID]] = Field(
        None, description="Array of unieke resource identifiers (UUID4)", title="uuid__in"
    )


class Inrichtingselement(ZaakObject, ObjectIdentificatieObjectInrichtingselement):
    pass


class Kunstwerkdeel(ZaakObject, ObjectIdentificatieObjectKunstwerkdeel):
    pass


class ObjectIdentificatieObjectHuishouden(BaseModel):
    objectIdentificatie: Optional[ObjectHuishouden] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectWozDeelobject(BaseModel):
    objectIdentificatie: Optional[ObjectWozDeelobject] = Field(None, title="objectIdentificatie")


class ObjectIdentificatieObjectZakelijkRecht(BaseModel):
    objectIdentificatie: Optional[ObjectZakelijkRecht] = Field(None, title="objectIdentificatie")


class WozDeelobject(ZaakObject, ObjectIdentificatieObjectWozDeelobject):
    pass


class ZakelijkRecht(ZaakObject, ObjectIdentificatieObjectZakelijkRecht):
    pass


class PaginatedZaakList(BaseModel):
    count: Optional[int] = Field(None, example=123)
    next: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=4")
    previous: Optional[AnyUrl] = Field(None, example="http://api.example.org/accounts/?page=2")
    results: Optional[List[Zaak]] = None


class Huishouden(ZaakObject, ObjectIdentificatieObjectHuishouden):
    pass
